CFB_DecryptionTemplate< BASE > Class Template Reference

Base class for feedback based stream ciphers in the reverse direction with SymmetricCipher interface. More...

Inheritance diagram for CFB_DecryptionTemplate< BASE >:

## Additional Inherited Members

Public Types inherited from CFB_CipherTemplate< AbstractPolicyHolder< CFB_CipherAbstractPolicy, SymmetricCipher > >
typedef AbstractPolicyHolder< CFB_CipherAbstractPolicy, SymmetricCipher > ::PolicyInterface | PolicyInterface
Public Types inherited from AbstractPolicyHolder< CFB_CipherAbstractPolicy, SymmetricCipher >
typedef CFB_CipherAbstractPolicy | PolicyInterface
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Member Functions inherited from CFB_CipherTemplate< AbstractPolicyHolder< CFB_CipherAbstractPolicy, SymmetricCipher > >
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Apply keystream to data. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize the cipher. More...
unsigned int | OptimalBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | GetOptimalNextBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | OptimalDataAlignment () const
| Provides number of ideal data alignment. More...
bool | IsRandomAccess () const
| Flag indicating random access. More...
bool | IsSelfInverting () const
| Determines if the cipher is self inverting. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length in bytes.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length in bytes.
virtual size_t | DefaultKeyLength () const =0
| Returns default (recommended) key length in bytes.
virtual size_t | GetValidKeyLength (size_t n) const =0
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsSelfInverting () const =0
| Determines whether the cipher is self-inverting. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

### template<class BASE = AbstractPolicyHolder<CFB_CipherAbstractPolicy, SymmetricCipher>>
class CFB_DecryptionTemplate< BASE >

Base class for feedback based stream ciphers in the reverse direction with SymmetricCipher interface.

Template Parameters

  BASE | AbstractPolicyHolder base class

Definition at line 560 of file strciphr.h.

The documentation for this class was generated from the following files:

- strciphr.h
- strciphr.cpp